# Automatically generated code: EDIT AT YOUR OWN RISK
from traits import api as traits
from traitsui.item import Item, spring
from traitsui.group import HGroup
from traitsui.view import View

from tvtk import vtk_module as vtk
from tvtk import tvtk_base
from tvtk.tvtk_base_handler import TVTKBaseHandler
from tvtk import messenger
from tvtk.tvtk_base import deref_vtk
from tvtk import array_handler
from tvtk.array_handler import deref_array
from tvtk.tvtk_classes.tvtk_helper import wrap_vtk


def InstanceEditor(*args, **kw):
    from traitsui.editors.api import InstanceEditor as Editor
    return Editor(view_name="handler.view")

try:
    long
except NameError:
    # Silly workaround for Python3.
    long = int

inf = float('inf')

from tvtk.tvtk_classes.synchronized_renderers import SynchronizedRenderers


class CompositedSynchronizedRenderers(SynchronizedRenderers):
    """
    CompositedSynchronizedRenderers -
    CompositedSynchronizedRenderers is SynchronizedRenderers that
    uses Compositer to composite the images on  the root node.
    
    Superclass: SynchronizedRenderers
    
    """
    def __init__(self, obj=None, update=True, **traits):
        tvtk_base.TVTKBase.__init__(self, vtk.vtkCompositedSynchronizedRenderers, obj, update, **traits)
    
    def _get_compositer(self):
        return wrap_vtk(self._vtk_obj.GetCompositer())
    def _set_compositer(self, arg):
        old_val = self._get_compositer()
        self._wrap_call(self._vtk_obj.SetCompositer,
                        deref_vtk(arg))
        self.trait_property_changed('compositer', old_val, arg)
    compositer = traits.Property(_get_compositer, _set_compositer, desc=\
        """
        Get/Set the composite. TreeCompositer is used by default.
        """
    )

    _updateable_traits_ = \
    (('automatic_event_handling', 'GetAutomaticEventHandling'),
    ('parallel_rendering', 'GetParallelRendering'), ('use_fxaa',
    'GetUseFXAA'), ('write_back_images', 'GetWriteBackImages'), ('debug',
    'GetDebug'), ('global_warning_display', 'GetGlobalWarningDisplay'),
    ('image_reduction_factor', 'GetImageReductionFactor'),
    ('root_process_id', 'GetRootProcessId'), ('reference_count',
    'GetReferenceCount'))
    
    _allow_update_failure_ = \
    ()
    
    _full_traitnames_list_ = \
    (['automatic_event_handling', 'debug', 'global_warning_display',
    'parallel_rendering', 'use_fxaa', 'write_back_images',
    'image_reduction_factor', 'root_process_id'])
    
    def trait_view(self, name=None, view_element=None):
        if view_element is not None or name not in (None, '', 'traits_view', 'full_traits_view', 'view'):
            return super(CompositedSynchronizedRenderers, self).trait_view(name, view_element)
        if name == 'full_traits_view':
            full_traits_view = \
            View((Item("handler._full_traits_list",show_label=False)),
            title='Edit CompositedSynchronizedRenderers properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return full_traits_view
        elif name == 'view':
            view = \
            View((['automatic_event_handling', 'parallel_rendering', 'use_fxaa',
            'write_back_images'], [], ['image_reduction_factor',
            'root_process_id']),
            title='Edit CompositedSynchronizedRenderers properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return view
        elif name in (None, 'traits_view'):
            traits_view = \
            View((HGroup(spring, "handler.view_type", show_border=True), 
            Item("handler.info.object", editor = InstanceEditor(view_name="handler.view"), style = "custom", show_label=False)),
            title='Edit CompositedSynchronizedRenderers properties', scrollable=True, resizable=True,
            handler=TVTKBaseHandler,
            buttons=['OK', 'Cancel'])
            return traits_view
            

